#include <stdio.h>
#include <stdlib.h>
#include <CUnit/Basic.h>
#include <CUnit/CUnit.h>
#include "problem0/Logic.h"
#include "problem1/BubbleSort.h"
#include "Problem3/OrderProcess.h"
#include "Problem3/Inventory.h"
#include "Problem3/CustomerRegister.h"
#include "Problem4/RiskAssessment.h"
#include "problem5/TrafficLight.h"

#include <stdio.h>
#include <stdlib.h>

// Simple test of logic().
void testLogic(void) {
	CU_ASSERT(doubleNegationLaw == true);
	CU_ASSERT(commutativeLaw == true);
	CU_ASSERT(associativeLaw == true);
	CU_ASSERT(distributeLaw == true);
	CU_ASSERT(deMorgansLaw == true);
	CU_ASSERT(absorbtionLaw == true);
}

// Simple test of bubbleSort().
void testBubbleSort(void) {
	int input[5] = { 1, 4, 5, 2, 3 };
	int output[5] = { 1, 2, 3, 4, 5 };
//	bubbleSort(input, 5);
	for (int i = 0; i < 5; i++) {
		if (input[i] != output[i]) {
			CU_FAIL("The Bubblesort function did not sort correctly")
		}
	}
	CU_ASSERT(0 == 0);
}

// Simple test of OrderProcess().
void testOrderProcess(void) {
	Item orderOneItems[] = { inventory[0], inventory[1], inventory[2] };
	Item orderTwoItems[] = { inventory[1], inventory[2], inventory[3] };
	Item orderThreeItems[] = { inventory[2], inventory[3], inventory[4] };
	Item orderFourItems[] = { inventory[3], inventory[4], inventory[0] };

	CU_ASSERT(processOrder(orderOneItems, customerRegister[0]) == 9375.000000);
	CU_ASSERT(processOrder(orderTwoItems, customerRegister[1]) == 13050.000000);
	CU_ASSERT(processOrder(orderThreeItems, customerRegister[2]) == -1);
	CU_ASSERT(processOrder(orderFourItems, customerRegister[3]) == 13068.750000);
}

// Simple test of Library().
void testLibrary(void) {

}

// Simple test of RiskAssessment().
void testRiskAssessment(void) {
//    CU_ASSERT(assessRisk(BAD_HISTORY, SENIOR) == HIGH)
//    CU_ASSERT(assessRisk(GOOD_HISTORY, SENIOR) == MEDIUM)
//    CU_ASSERT(assessRisk(BAD_HISTORY, ADULT) == HIGH)
//    CU_ASSERT(assessRisk(GOOD_HISTORY, ADULT) == LOW)
//    CU_ASSERT(assessRisk(BAD_HISTORY, YOUTH) == MEDIUM)
//    CU_ASSERT(assessRisk(GOOD_HISTORY, YOUTH) == LOW)

}

// Simple test of TrafficLight().
void testTrafficLight(void) {
	Instance instance = { };
	init(&instance);
	CU_ASSERT(instance.currentState == RED)
	//TrafficLight(&instance, GO_TO_YELLOW);
	CU_ASSERT(instance.currentState == YELLOW)
	//TrafficLight(&instance, GO_TO_GREEN);
	CU_ASSERT(instance.currentState == GREEN)
	//TrafficLight(&instance, GO_TO_YELLOW);
	CU_ASSERT(instance.currentState == YELLOW)
	//TrafficLight(&instance, GO_TO_RED);
	CU_ASSERT(instance.currentState == RED)

}

/* Test Suite setup and cleanup functions: */

int init_suite(void) {
	return 0;
}
int clean_suite(void) {
	return 0;
}

int RunAllTests(void) {
	CU_pSuite pSuite = NULL;

	/* initialize the CUnit test registry */
	if (CUE_SUCCESS != CU_initialize_registry())
		return CU_get_error();

	/* add a suite to the registry */
	pSuite = CU_add_suite("Suite", init_suite, clean_suite);
	if (NULL == pSuite) {
		CU_cleanup_registry();
		return CU_get_error();
	}

	/* add the tests to the suite */
	if ((NULL == CU_add_test(pSuite, "Problem0: Logic", testLogic))
			|| (NULL
					== CU_add_test(pSuite, "Problem1: Algorithm",
							testBubbleSort))
			|| (NULL == CU_add_test(pSuite, "Problem2: Library", testLibrary))
			|| (NULL
					== CU_add_test(pSuite, "Problem3: Refactoring",
							testOrderProcess))
			|| (NULL
					== CU_add_test(pSuite, "Problem4: RiskAssessment",
							testRiskAssessment))
			|| (NULL
					== CU_add_test(pSuite, "Problem5: TrafficLight",
							testTrafficLight))

			) {
		CU_cleanup_registry();
		return CU_get_error();
	}

	/* Run all tests using the CUnit Basic interface */
	CU_basic_set_mode(CU_BRM_VERBOSE);
	CU_basic_run_tests();
	CU_cleanup_registry();
	return CU_get_error();
}
int main(int argc, char* argv[]) {
	return RunAllTests();
}

